<template>
  <div class="">
    <div class="flex flex-row items-center justify-between font-medium">
      <i
        @click="currentMonth = currentMonth.minus({ months: 1 })"
        class="hero chevron-left solid clickable p-2 rounded-full hover:bg-gray-200 text-lg"
      ></i>
      <div class="text-sm">
        {{ currentMonth.monthLong }} {{ currentMonth.year }}
        <!-- <i class="hero chevron-down solid"></i> -->
      </div>
      <i
        @click="currentMonth = currentMonth.plus({ months: 1 })"
        class="hero chevron-right solid clickable p-2 rounded-full hover:bg-gray-200 text-lg"
      ></i>
    </div>
    <div class="mt-4 -mx-2">
      <div class="text-gray-500 text-xs flex flex-row items-center justify-between row font-medium">
        <div v-for="day of 'MTWTFSS'.split('')" :key="day" class="p-2 flex-1 text-center">{{ day }}</div>
      </div>
      <div v-for="(week, index) of weeks" :key="index" class="text-sm flex flex-row items-center justify-between row">
        <div
          v-for="day of week"
          :key="day.date.weekday"
          class="flex-1 text-center flex flex-row items-center justify-center w-10 h-10"
        >
          <div
            v-if="!day.isOutOfMonth"
            @click="dayClick(day)"
            class="rounded-full day clickable flex flex-row items-center justify-center w-full h-full"
            :class="{ 'text-blue-700': day.isToday && !day.isSelected, 'bg-blue-700 text-white': day.isSelected }"
          >
            {{ day.date.day }}
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { computed, ref } from "@vue/runtime-core";
import { DateTime } from "luxon";
export default {
  props: {
    value: {
      type: DateTime
    }
  },
  emits: ["date-click"],
  setup(props, context) {
    const currentMonth = ref(DateTime.local());

    return {
      currentMonth,
      dayClick: (day: any) => context.emit("date-click", day.date),
      weeks: computed(() => {
        const first = currentMonth.value.startOf("month").startOf("week");
        const last = currentMonth.value.endOf("month").endOf("week");

        const sortedByWeeks: { [key: string]: Array<{}> } = {};
        let current = first;
        do {
          if (!sortedByWeeks[current.startOf("week").toISODate()]) {
            sortedByWeeks[current.startOf("week").toISODate()] = [];
          }
          sortedByWeeks[current.startOf("week").toISODate()].push({
            isToday: Math.floor(current.diffNow("days").days) == -1,
            isSelected: props.value?.hasSame(current, "day"),
            isOutOfMonth: current.month != currentMonth.value.month,
            date: current
          });
          current = current.plus({ days: 1 });
        } while (current.toMillis() <= last.toMillis() || Object.keys(sortedByWeeks).length < 6);

        return Object.keys(sortedByWeeks).reduce((weeks, current) => [...weeks, sortedByWeeks[current]], [] as {}[][]);
      })
    };
  }
};
</script>

<style lang="stylus" scoped>
.row
    + .row
        @apply mt-2
    > * + *
        @apply ml-1
    .day:not(.bg-blue-700):hover
        @apply bg-gray-200
</style>
